'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _typeof = typeof Symbol === "function" && typeof Symbol.iterator === "symbol" ? function (obj) { return typeof obj; } : function (obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; };

exports.default = function (ComponentStyle) {
  var createStyledComponent = function createStyledComponent(target, rules, props, parent) {
    if (target !== null && (typeof target === 'undefined' ? 'undefined' : _typeof(target)) === 'object') {
      var mergedProps = Object.assign({}, target.props, props);
      return createStyledComponent(target.displayName, target.rules.concat(rules), mergedProps, target);
    }

    var componentStyle = new ComponentStyle(rules);
    var ParentComponent = parent || {};

    var StyledComponent = Object.assign({}, ParentComponent, {
      props: props,

      render: function render(createElement) {
        return createElement(target, {
          class: [this.generatedClassName]
        }, this.$slots.default);
      },
      methods: {
        generateAndInjectStyles: function generateAndInjectStyles(componentProps) {
          return componentStyle.generateAndInjectStyles(componentProps);
        }
      },
      computed: {
        generatedClassName: function generatedClassName() {
          var componentProps = Object.assign({}, this.$props);
          return this.generateAndInjectStyles(componentProps);
        }
      }
    });

    StyledComponent.displayName = target;
    StyledComponent.rules = rules;

    return StyledComponent;
  };

  return createStyledComponent;
};

module.exports = exports['default'];